import { ClassTransformOptions } from 'class-transformer';
import { ClassType, TransformValidationOptions } from 'class-transformer-validator';
import { ClassConstructor } from './interfaces/class-constructor.type';
export * from './decorators/ArrayMember';
export * from './storage';
export * from './exceptions';
export declare function plainArrayToClass<T>(target: ClassConstructor<T>, array: unknown[], options?: ClassTransformOptions): T;
export declare function plainArrayToClasses<T>(target: ClassConstructor<T>, array: unknown[][], options?: ClassTransformOptions): T[];
export declare function classToPlainArray<T>(object: T, options?: ClassTransformOptions): unknown[] | null;
export declare function classToPlainArray<T>(object: T[], options?: ClassTransformOptions): unknown[][] | null;
export declare function arrayTransformAndValidate<T extends object>(target: ClassType<T>, array: unknown[], options?: TransformValidationOptions): Promise<T>;
export declare function arrayTransformAndValidates<T extends object>(target: ClassType<T>, array: unknown[][], options?: TransformValidationOptions): Promise<T[]>;
//# sourceMappingURL=index.d.ts.map