"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayTransformAndValidates = exports.arrayTransformAndValidate = exports.classToPlainArray = exports.plainArrayToClasses = exports.plainArrayToClass = void 0;
const class_transformer_1 = require("class-transformer");
const class_transformer_validator_1 = require("class-transformer-validator");
const storage_1 = require("class-transformer/storage");
const exceptions_1 = require("./exceptions");
const storage_2 = require("./storage");
__exportStar(require("./decorators/ArrayMember"), exports);
__exportStar(require("./storage"), exports);
__exportStar(require("./exceptions"), exports);
const nonClassTypes = [String.name, Number.name, Boolean.name, RegExp.name];
function plainMapValues(target, array) {
    const map = storage_2.storage.get(target);
    if (!map) {
        throw new exceptions_1.UnknownClassError(`Cannot found class of ${target.name}`);
    }
    const obj = {};
    for (const [i, o] of array.entries()) {
        const property = map.get(i);
        if (property) {
            if (!nonClassTypes.includes(property.type)) {
                const subTarget = storage_1.defaultMetadataStorage.findTypeMetadata(target, property.key)?.typeFunction();
                if (storage_2.storage.has(subTarget)) {
                    // eslint-disable-next-line @typescript-eslint/no-explicit-any
                    obj[property.key] = Array.isArray(o) ? plainMapValues(subTarget, o) : o;
                }
                else if (Array.isArray(o) && o.length) {
                    throw new exceptions_1.UnknownTypeError(`Cannot found type ${property.type}/${subTarget?.name} for ${target.name}.${property.key}. Make sure to use @Type for class property`);
                }
            }
            else {
                obj[property.key] = o;
            }
        }
    }
    return obj;
}
function plainArrayToClass(target, array, options) {
    return class_transformer_1.plainToClass(target, plainMapValues(target, array), options);
}
exports.plainArrayToClass = plainArrayToClass;
function plainArrayToClasses(target, array, options) {
    return class_transformer_1.plainToClass(target, array.map((arr) => plainMapValues(target, arr)), options);
}
exports.plainArrayToClasses = plainArrayToClasses;
function classMapValue(target, object) {
    const map = storage_2.storage.get(target);
    if (!map) {
        throw new exceptions_1.UnknownClassError(`Cannot found class of ${target.name}`);
    }
    const arr = [];
    for (const [i, o] of map.entries()) {
        const property = map.get(i);
        if (property && o.key in object) {
            if (!nonClassTypes.includes(property.type)) {
                const subTarget = storage_1.defaultMetadataStorage.findTypeMetadata(target, property.key)?.typeFunction();
                if (storage_2.storage.has(subTarget)) {
                    // eslint-disable-next-line @typescript-eslint/no-explicit-any
                    arr.push(classMapValue(subTarget, object[property.key]));
                }
            }
            else {
                arr.push(object[o.key]);
            }
        }
        else {
            arr.push(undefined);
        }
    }
    return arr;
}
function classToPlainArray(object, options) {
    if (Array.isArray(object) && !object.length) {
        return [];
    }
    const record = class_transformer_1.classToPlain(object, options);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const c = Array.isArray(object) ? object[0].constructor : object.constructor;
    if (Array.isArray(object)) {
        return record.map((o) => classMapValue(c, o));
    }
    else {
        return classMapValue(c, record);
    }
}
exports.classToPlainArray = classToPlainArray;
// eslint-disable-next-line @typescript-eslint/ban-types
function arrayTransformAndValidate(target, array, options) {
    return class_transformer_validator_1.transformAndValidate(target, plainMapValues(target, array), options);
}
exports.arrayTransformAndValidate = arrayTransformAndValidate;
// eslint-disable-next-line @typescript-eslint/ban-types
function arrayTransformAndValidates(target, array, options) {
    return class_transformer_validator_1.transformAndValidate(target, array.map((arr) => plainMapValues(target, arr)), options);
}
exports.arrayTransformAndValidates = arrayTransformAndValidates;
//# sourceMappingURL=index.js.map